/* Ankur Parikh
   DiscountComputer.hpp

   computes discounts according to Algorithm 1 in EMNLP 2014 paper
   */

#pragma once 

#include <Eigen/Dense>
#include <Eigen/Sparse>
#include "EigenHelper.hpp"

using namespace Eigen;

using namespace std;

class DiscountComputer
{
public:

    // computes discount matrix (disc_mat), leftover weights (gamma) from bigrams and powered bigrams (p_bigrams) 
    //where P is the power, modD is the modified discount scaling factors
    static void ComputeDiscount(SparseMatrix<double>& disc_mat, VectorXd& gamma, SparseMatrix<double>& bigrams,
        SparseMatrix<double>& p_bigram, double P, vector<double> modD);
};





