/* Ankur Parikh
   IWittenBell.hpp

   interpolated witten bell algorithm, this class is unnecessary */



#pragma once 

#include <Eigen/Dense>
#include <Eigen/Sparse>
#include "SMatrixArray.hpp"
#include <limits>
#include <vector>
#include <set>
#include "SpecMoments.hpp"
#include "eigen_boost_serialization.hpp"

using namespace std;
using namespace Eigen;


class IWittenBell {

private:

    SpecMoments* spec_mom;

    map<pair<int, int>, int>* b_n1plus_counts; // num unique words that follow a given pair
    map<int, int>* u_n1plus_counts; // num unique words that follow a given word

    friend class boost::serialization::access;

    template<typename Archive>
    void serialize(Archive& ar, const unsigned version) {

        //	ar & spec_mom;
        //	ar & b_n1plus_counts; 
        //	ar & u_n1plus_counts;
    }

public:

    IWittenBell()
    {
        b_n1plus_counts = NULL;
        u_n1plus_counts = NULL;

    }

    IWittenBell(SpecMoments* spec_mom);

    ~IWittenBell()
    {
        delete(b_n1plus_counts);
        delete(u_n1plus_counts);
    }

    void ComputeUCounts();
    void ComputeBCounts();

    void GetWeightVec(VectorXd& weights);

    double GetBiWeight(int i); // leftover bigram weight
    double GetTriWeight(int i, int j); // leftover trigram weight

    double GetHistCounts(pair<int, int> p);

    double GetHistCounts(int c);
    double GetN1Plus(int c);

    double GetN1Plus(pair<int, int> p);

    void WittenBellBigram(MatrixXd& smoothed_P21);

};
