/* Ankur Parikh
   PowerBigram.hpp

   abstract class for bigram in a power low rank ensemble,
   implemented by PowerFullBigram.hpp and PowerLRBigram.hpp */

#pragma once

#include "eigen_boost_serialization.hpp"

class PowerBigram
{
public:

    virtual double LRDiscAt(int i, int j) = 0;

    virtual double CondLRDiscAt(int i, int j) = 0;

    virtual double GammaAt(int j) = 0;

    virtual ~PowerBigram() {}
};
