/* Ankur Parikh
   PowerQuadgram.hpp

   abstract class for quadgram in a power low rank ensemble,
   implemented by PowerFullQuadgram.hpp and PowerLRQuadgram.hpp */

#pragma once

class PowerQuadgram
{

public:

    virtual double LRDiscAt(int i, int j, int k, int l) = 0;

    virtual double CondLRDiscAt(int i, int j, int k, int l) = 0;

    virtual double GammaAt(int j, int k, int l) = 0;

    virtual ~PowerQuadgram() {}
};