/* Ankur Parikh
   PowerTrigram.hpp

   abstract class for trigram in a power low rank ensemble,
   implemented by PowerFullTrigram.hpp and PowerLRTrigram.hpp */

#pragma once

class PowerTrigram
{

public:

    virtual double LRDiscAt(int i, int j, int k) = 0;

    virtual double CondLRDiscAt(int i, int j, int k) = 0;

    virtual double GammaAt(int j, int k) = 0;

    virtual ~PowerTrigram() {}
};