/* Ankur Parikh
   Tensor.hpp

   abstract class for Tensors
   */

# pragma once

#include <vector>
#include <complex>
#include <Eigen/Dense>
#include "eigen_boost_serialization.hpp"

using namespace std;
using namespace Eigen;

typedef complex<double> dcomplex;
typedef Matrix<dcomplex, Dynamic, Dynamic> MatrixXc;
typedef Matrix<dcomplex, Dynamic, 1> VectorXc;

using namespace std;

template <class T>
class Tensor {


public:

    virtual vector<int>& Dims() = 0;
    virtual int Dim(int index) = 0;


    // access elements of tensor
    virtual T At(int i, int j, int k) = 0;
};


