// serialization code for tuples, from StackOverflow

#pragma once 

#include <boost/serialization/serialization.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/split_free.hpp>
#include <boost/tuple/tuple.hpp>
#include <boost/tuple/tuple_comparison.hpp>
#include <boost/tuple/tuple_io.hpp>
#include <boost/functional/hash.hpp>
//#include "serialize_unordered_map.hpp"

using namespace std;

typedef boost::tuple<int, int, int> itriple;
typedef boost::tuple<int, int, int, int> iquadple;

struct hash_P{
    size_t operator()(const pair<int, int>& x) const{
        return boost::hash<int>()(x.first) ^ boost::hash<int>()(x.second);
    }
};

struct hash_T{
    size_t operator()(const itriple& x) const{
        return boost::hash<int>()(x.get<0>()) ^ boost::hash<int>()(x.get<1>()) ^ boost::hash<int>()(x.get<2>());
    }
};

struct hash_Q{
    size_t operator()(const iquadple& x) const{
        return boost::hash<int>()(x.get<0>()) ^ boost::hash<int>()(x.get<1>()) ^ boost::hash<int>()(x.get<2>()) ^ boost::hash<int>()(x.get<3>());
    }
};


namespace boost {
    namespace serialization {
        class access;
    }
}

namespace boost {
    namespace serialization {

        template <class Archive>
        void save(Archive & ar, const itriple t, const unsigned int version) {
            ar & t.get<0>();
            ar & t.get<1>();
            ar & t.get<2>();
        }
        template <class Archive>
        void load(Archive & ar, itriple & t, const unsigned int version) {
            int val1, val2, val3;
            ar & val1;
            ar & val2;
            ar & val3;
            t = boost::make_tuple(val1, val2, val3);
        }

        template <class Archive>
        void serialize(Archive & ar, itriple & t, const unsigned int version) {
            split_free(ar, t, version);
        }

        template <class Archive>
        void save(Archive & ar, const iquadple q, const unsigned int version) {
            ar & q.get<0>();
            ar & q.get<1>();
            ar & q.get<2>();
            ar & q.get<3>();
        }
        template <class Archive>
        void load(Archive & ar, iquadple & q, const unsigned int version) {
            int val1, val2, val3, val4;
            ar & val1;
            ar & val2;
            ar & val3;
            ar& val4;
            q = boost::make_tuple(val1, val2, val3, val4);
        }

        template <class Archive>
        void serialize(Archive & ar, iquadple & q, const unsigned int version) {
            split_free(ar, q, version);
        }



    }
}

